<template>
  <div class="cardinfo">
    <!-- margin: 0rpx -9999px; -->
    <div class="code" v-if="couponStatus === '未使用'">
        <div class="qrcode">
              <image bindtap="previewImg" mode="widthFix" :src="imagePath"  class="img1" ></image>
              <canvas style="width:225px;height:225px;position: absolute;top: 0px;margin: 0rpx -9999px;" canvas-id="mycanvas"  ></canvas>
          </div>
          <!-- <div class="barcode" >
             <image bindtap="previewImg" mode="widthFix" :src="imagePath1" class="img2" ></image>
              <canvas style="width:454px;height:60px;position: absolute;bottom: 0px;margin: 0rpx -9999px;" canvas-id="barcode" ></canvas>
          </div>  -->
          <div class="num">{{datas.couponNo}}</div>
    </div>
    <v-text :text="text" @textclick="textevent"></v-text>
    <div class="notify">
      <div class="text">使用须知</div>
      <div class="text">{{datas.usageNotice?datas.usageNotice:''}}</div>
    </div>
    <div style="margin-top:62rpx" @click="share" v-if="couponStatus === '未使用'">
      <div @click="share">
       <button open-type="share" class="footer">礼券转赠</button>
       </div>
    </div>
  </div>
</template>

<script>
// import {get} from '@/utils/request'
import config from '@/config'
  import {VeevlinkLogin,VeevlinkIslogin,VeevlinkClient,VeevlinkData} from '@/utils/base'
  import {get,showToast,setStorageSync,getStorageSync,scanCode} from '@/util'
  import store from '@/store'
  import hintbox from '@/components/hintbox/hintbox.vue'
  import footer from '@/components/footer/footer.vue'
  import text from '@/components/text/text.vue'
 import areadata from '@/utils/area.js'
 import QR from '@/utils/qrCode.js'
  import barcode from '@/utils/barcode.js'
export default {
  data () {
    return {
      couponId:'',
      couponNo:'',
      imagePath:'',
      imagePath1:'',
      couponStatus:'',
      datas:{
        usageNotice:'',
        couponNo:''
      },
      multiArray3: [[], [], []],
      multiIndex3: [0, 0, 0],
      areaCode: '',
      sheng: '',
      shi: '',
      qu: '',
      address: '',
      text:[
        {
          title:'名称',
          text:''
        },
         {
          title:'状态',
          text:''
        },
         {
          title:'类型',
          text:''
        },
         {
          title:'有效期',
          text:''
        },
         {
          title:'适用门店',
          text:''
        },
         {
          title:'适用类型',
          text:''
        }

      ]
    }
  },
   components:{
       'v-hintbox' : hintbox,
       'v-footer' : footer,
       'v-text' : text,
    },
     //分享朋友
      onShareAppMessage:function(options){
           console.log('分享');
        　　var that = this;
        　　// 设置菜单中的转发按钮触发转发事件时的转发内容
        　　var shareObj = {
        　　　　title: "礼券转赠",        // 默认是小程序的名称(可以写slogan等)
        　　　　path: '/pages/mycard/recieve/main?couponId='+this.couponId + '&couponNo=' +this.couponNo,        // 默认是当前页面，必须是以‘/’开头的完整路径
        　　　　imgUrl: '',     //自定义图片路径，可以是本地文件路径、代码包文件路径或者网络图片路径，支持PNG及JPG，不传入 imageUrl 则使用默认截图。显示图片长宽比是 5:4
        　　　　success: function(res){
                  console.log('成功',res);
        　　　　　　// 转发成功之后的回调
        　　　　　　if(res.errMsg == 'shareAppMessage:ok'){
        　　　　　　}
        　　　　},
        　　　　fail: function(res){
        　　　　　　// 转发失败之后的回调
                  console.log('成功',res);
        　　　　　　if(res.errMsg == 'shareAppMessage:fail cancel'){
        　　　　　　　　// 用户取消转发
        　　　　　　}else if(res.errMsg == 'shareAppMessage:fail'){
        　　　　　　　　// 转发失败，其中 detail message 为详细失败信息
        　　　　　　}
        　　　　},
        　　　　complete(res){
        　　　　　　// 转发结束之后的回调（转发成不成功都会执行）
                  console.log('完成',);
        　　　　}
        　　};
        　　// 来自页面内的按钮的转发
        　　if( options.from == 'button' ){
               console.log('页面按钮转发',options);
        　　　　var eData = options.target.dataset;
        　　　　console.log('eData',eData);     // shareBtn
        　　　　// 此处可以修改 shareObj 中的内容
        　　　　shareObj.path = '/pages/mycard/recieve/main?couponId='+this.couponId + '&couponNo=' +this.couponNo;
               console.log('shareObj',shareObj);
        　　}
        　　// 返回shareObj
        　　return shareObj;
        },
  methods: {
    textevent(data){
      let that = this;
      if(data === '适用门店'){
         config.href(config.mycard.store +'?data='+ that.datas.storeList);
      }
      if(data === '适用类型'){
        config.href(config.mycard.type + '?data='+that.datas.productType);
        
      }
    },
    //生成二维码
        createQrCode: function (canvasId, cavW, cavH) {
        let url = this.datas.couponNo;
        //调用插件中的draw方法，绘制二维码图片
        QR.api.draw(url, 'mycanvas', '225', '225');
        setTimeout(() => { this.canvasToTempImage(); }, 500);
      },
      canvasToTempImage: function () {
        var that = this;
        wx.canvasToTempFilePath({
            canvasId: 'mycanvas',
            success: function (res) {
                var tempFilePath = res.tempFilePath;
                console.log('生成临时图片路径。。。。',tempFilePath);
                that.imagePath = tempFilePath;
              },
              fail: function (res) {
                  console.log(res);
              }
        });
      },
        createQrCode1: function (canvasId, cavW, cavH) {
        let url = this.datas.couponNo;
        //调用插件中的draw方法，绘制二维码图片   
        barcode.code128(wx.createCanvasContext('barcode'), 'url', '454', '60');
        setTimeout(() => { this.canvasToTempImage1(); }, 500);
      },
      canvasToTempImage1: function () {
        var that = this;
        wx.canvasToTempFilePath({
            canvasId: 'barcode',
            success: function (res) {
                var tempFilePath = res.tempFilePath;
                console.log('生成临时图片路径1。。。。',tempFilePath);
                that.imagePath1 = tempFilePath;
              },
              fail: function (res) {
                  console.log(res);
              }
        });
      },
    //礼券转赠
    enter(){

    },
     //首页接口
      getAjax(data){
        let that = this;
        let VerificationCodeEntity =  wx.getStorageSync('informationwx23bcedfe9e867c13');
        let memberId = wx.getStorageSync('memberid');
        VeevlinkClient(
          '/member/coupon/info?openId='+VerificationCodeEntity.OpenId + '&couponId='+data.couponId +'&platform=wechat' + '&couponNo='+data.couponNo,
          'GET',
          '',
          function (data) {
            console.log(data);
            if(data.success){
              if(data.records[0]){
                that.datas = data.records[0];
                that.text[0].text = that.datas.couponName?that.datas.couponName:'';
                that.text[1].text = that.datas.couponStatus?that.datas.couponStatus:'';
                that.text[2].text = that.datas.couponType?that.datas.couponType:'';
                that.text[3].text = that.datas.startDate +'~'+that.datas.endDate;
                that.text[4].text = that.datas.storeList.length;
                that.text[5].text = that.datas.productType.length;
                console.log('text',that.text);
                if(that.couponStatus === '未使用'){
                  that.createQrCode();
                  that.createQrCode1();
                }
                
                
              }else{
                
              }
              
            }else{
              that.hintbox.show = true;
              that.hintbox.text = success.message;
            }
          },
          function (error) {
            console.log(error);
          })
      },
  },
  onLoad(data) {
    this.getAjax(data);
    this.couponStatus = data.couponStatus;
    this.couponNo = data.couponNo;
    this.couponId = data.couponId;
  }
}
</script>

<style lang="scss"  type="text/scss" scoped>
.cardinfo{
  .code{
    margin: 0.3rem auto;
    .img1{
       width:2.25rem;
       height:2.25rem;
       left: 2.63rem;
       position:relative;
    }
    .img2{
       width:4.54rem;
       height:0.6rem;
       left: 1.48rem;
       position:relative;
    }
    .num{
      color:#727171;
      font-size:0.28rem;
      text-align:center;
      margin-top:0.25rem;
    }
  }
  .notify{
    margin:0 0.7rem;
    div{
      color:#727171;
      font-size:0.26rem;

    }
  }
   .footer{
    background-color: #919191;
    font-size: 0.24rem;
    color: #fff;
    text-align: center;
    height: 0.6rem;
    line-height: 0.6rem;
    margin: 0.52rem 0.7rem;
    width: 6rem;
    position:relative;
    border-radius:0px;
    // top:-200px;

  }
  
}
</style>
